
;;; =============================================================== ;;;
;;; 
;;; Copyright (C) 2004 Daniel Mayer (post.dm@gmx.at) 
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or (at your option) any later version.
;;; 
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;; 
;;; =============================================================== ;;;

;;; Gentlecoord 1.0
;;; Last Revision: 16.6.04


;;; Input storage


(defclass pat-events-options ()
  ((dyn :initform nil
             :initarg :dyn :initarg dyn)
   (no-8 :initform nil
         :initarg :no-8 :initarg no-8)
   (no-1 :initform nil
         :initarg :no-1 :initarg no-1)
   (voice-order :initform nil
                :initarg :voice-order :initarg voice-order)
   (tempo :initform nil
          :initarg :tempo :initarg tempo)
   (beat :initform nil
         :initarg :beat :initarg beat)
   (abs-times :initform nil
              :initarg :abs-times :initarg abs-times) 
   (print :initform nil
          :initarg :print :initarg print)
   (transpose-to-bounds :initform nil
                        :initarg :transpose-to-bounds :initarg transpose-to-bounds)
   (max-next :initform nil
             :initarg :max-next :initarg max-next)
   (voice-shift :initform nil
                :initarg :voice-shift :initarg voice-shift)
   (max-time :initform nil
             :initarg :max-time :initarg max-time)
   (dur-factor :initform nil
               :initarg :dur-factor :initarg dur-factor)
   (unlock-backward-shift :initform nil
                          :initarg :unlock-backward-shift :initarg :unlock-backward-shift)
   (no-reps :initform nil
            :initarg :no-reps :initarg no-reps)
   (no-8-steps :initform nil
               :initarg :no-8-steps :initarg no-8-steps) 
   (max-buffer-length :initform nil
                      :initarg :max-buffer-length :initarg max-buffer-length) 
   (to :initform nil
       :initarg :to :initarg to)
   (step-start :initform nil
               :initarg :step-start :initarg step-start)
   (strict-step-start :initform nil
                      :initarg :strict-step-start :initarg strict-step-start)
   (max-step :initform nil
             :initarg :max-step :initarg max-step)
   (lb :initform nil
       :initarg :lb :initarg lb)
   (ub :initform nil
       :initarg :ub :initarg ub)
   (pitch-scale :initform nil
                :initarg :pitch-scale :initarg pitch-scale)  
   (sleep :initform nil
          :initarg :sleep :initarg sleep)
   (level :initform nil
          :initarg :level :initarg level)
   (level-change-step-time :initform nil
                           :initarg :level-change-step-time :initarg level-change-step-time)
   (min-level-change-steps :initform nil
                           :initarg :min-level-change-steps :initarg min-level-change-steps)
   (base :initform nil
         :initarg :base :initarg base)
   (level-shape-shrink :initform nil
                       :initarg :level-shape-shrink :initarg level-shape-shrink)
   (level-change-delay :initform nil
                       :initarg :level-change-delay :initarg level-change-delay)
   (level-change-break :initform nil
                       :initarg :level-change-break :initarg level-change-break)
   (v-data-pats :initform nil
                :initarg :v-data-pats :initarg v-data-pats)
   (v-rhythm-pats :initform nil
                  :initarg :v-rhythm-pats :initarg v-rhythm-pats)
   (v-print :initform nil
            :initarg :v-print :initarg v-print)
   (v-tempo :initform nil
            :initarg :v-tempo :initarg v-tempo)
   (v-beat :initform nil
           :initarg :v-beat :initarg v-beat)
   (v-abs-times :initform nil
                :initarg :v-abs-times :initarg v-abs-times)
   (v-max-time :initform nil
               :initarg :v-max-time :initarg v-max-time)
   (v-voice-order :initform nil
                  :initarg :v-voice-order :initarg v-voice-order)
   (input-data-check :initform nil
                     :initarg :input-data-check :initarg input-data-check)
   (runtime-data-check :initform nil
                       :initarg :runtime-data-check :initarg runtime-data-check)
   (mf-tempo :initform nil
             :initarg :mf-tempo :initarg mf-tempo)
   (mf-measure :initform nil
               :initarg :mf-measure :initarg mf-measure)))


(defvar *pe-default-obj*)


(setf *pe-default-obj*
      (make-instance 'pat-events-options
        :dyn 90
        :tempo 60
        :beat 0.25
        :max-next 100
        :max-time 60
        :voice-shift 0.00001
        :unlock-backward-shift 0.0005
        :dur-factor 1
        :sleep 0.5
        :level 127
        :level-change-step-time 0.03
        :min-level-change-steps 2
        :base 1
        :level-shape-shrink 0.9
        :level-change-delay 0.06
        :level-change-break 0.06
        :v-tempo 60
        :v-beat 0.25
        :v-max-time 60
        :input-data-check t
        :mf-tempo 60
        :mf-measure '(4 4)))


; Utility class


(defclass sop-cycle (cycle) 
  ((last-state :initarg last-state
               :initarg :last-state
               :initform nil)))


(setf (get 'sop-cycle ':new-expander)
      #'(lambda (inits) 
          `(make-instance 'sop-cycle  :last-state :not-a-datum ., (expand-pattern-args inits) )))


(if-cm-version>= (2 4)  
    
    (defmethod next-1 :before ((p sop-cycle))             
      (declare (ignore num))
      (setf (slot-value p 'last-state)
            (slot-value p 'state)))
    
    (defmethod next :before ((p sop-cycle) &optional num)             
      (declare (ignore num))
      (setf (slot-value p 'last-state)
            (slot-value p 'state))))


(defmacro with-all-slots (var class &rest forms)
  (let ((slot-list (gensym)))
    (setf slot-list (slot-list class))
    `(symbol-macrolet , (loop for slot in slot-list collect 
                              `(,slot (slot-value ,var ',slot)))
       ,@ forms)))


(defun make-pe-options-object (option-args)
  (let ((obj (copy-tree-obj *pe-default-obj*)))
    (loop for (x y) on option-args by #'cddr do
          (setf (slot-value obj (symbol-of-key x)) y))
    obj))


(defun subordinate-pe-options (sub-key super-key args pe-options-obj)  ; transforming pe-options-obj
  (let (val param)
    (if (and (not (member sub-key args))
             (setf param (member super-key args))
             (or (not (listp (setf val (cadr param))))
                 (null val)))
        (setf (slot-value pe-options-obj (symbol-of-key sub-key))
              (slot-value pe-options-obj (symbol-of-key super-key))))))
    
  
(defun redefine-pe-grouping (pe-options-obj slot-name density) ; transforming pe-options-obj
  (cond ((null (slot-value pe-options-obj slot-name)))
        ((eql (slot-value pe-options-obj slot-name) t)
         (setf (slot-value pe-options-obj slot-name)
               (list (range-list (1- density)))))
        (t (slot-value pe-options-obj slot-name))))


(defmacro wrap-in-named-pattern (x type name)
  `(new ,type :of ,x :name ,name))


(defun redefine-step-start (pe-options-obj name-root-string) ; transforming pe-options-obj
  (with-slots (step-start) pe-options-obj
    (if (not (null step-start))
        (setf step-start
              (map-anyway  step-start
                           #'(lambda (x &optional i) 
                               (if (and (pattern? x)
                                        (not (object-name x)))
                                 (wrap-in-named-pattern x sop-cycle 
                                                        (concatenate 'string name-root-string (write-to-string i)))
                                 x)))))))


(defun symbol-pat-reference  (symbol v-data-pats  with-error)
  (let ((pat (find-object (symbol-name symbol) nil 'pattern)))
    (cond ((null pat)
           (format t "~2%Failing pattern reference with symbol: No pattern named ~A~2%" symbol)
           (if with-error (error "")))
          ((not (member pat (listify v-data-pats)))
           (format t (concatenate 'string "~2%Failing pattern reference with symbol: "
                                  "No pattern named ~A defined as v-data-pattern~2%") symbol)
           (if with-error (error "")))
          (t pat))))



(defvar *pe-vo-option-key-vec*)
(setf *pe-vo-option-key-vec*       
      (coerce 
       (nreverse 
        (mapcar #'symbol-keywordify 
                (delete-if #'(lambda (x) 
                               (member x '(sleep voice-order v-voice-order v-rhythm-pats 
                                           v-data-pats v-print v-tempo v-beat v-abs-times v-max-time
                                           v-voice-order input-data-check mf-measure) 
                                       :test #'symbol-name-eql?)) 
                           (cons :output-type (nreverse (slot-list 'pat-events-options))))))
       'array))


(defvar *vo-option-key-vec*)
(setf *vo-option-key-vec*
      (repl-seq-items (copy-seq *pe-vo-option-key-vec*)
                      '(:no-8 :avoid-octaves-group :no-1 :avoid-primes-group :no-reps :pitch-rep-horizon 
                        :no-8-steps :octave-step-horizon)))


(defvar *vo-option-num*)
(setf *vo-option-num* (length *pe-vo-option-key-vec*))
 

(defvar *vo-non-dynamic-option-key-vec*)
(setf *vo-non-dynamic-option-key-vec*
      #(:tempo :beat :abs-times :max-time :strict-step-start :level 
        :output-type :max-buffer-length :runtime-data-check :mf-tempo))



(defun max-buffer-max (&rest nums)
  (apply #'max 
         (mapcar #'(lambda (x) (cond ((or (null x) (symbolp x) (pattern? x)) 1)
                                     (t x))) 
                 nums)))


(defun redefine-pe-buffer-length (pe-options-obj density) ; transforming pe-options-obj
 (let (data)
  (setf (slot-value pe-options-obj 'max-buffer-length)
        (cond ((some #'consp (setf data
                                   (list
                                    (slot-value pe-options-obj 'no-reps)
                                    (slot-value pe-options-obj 'no-8-steps)
                                    (slot-value pe-options-obj 'max-buffer-length))))
               (loop for i below density collect
                     (max-buffer-max (if-nth i (car data)) 
                                     (if-nth i (cadr data)) 
                                     (if-nth i (caddr data)))))
              (t (max-buffer-max 
                      (car data)
                      (cadr data)
                      (caddr data)))))))


;;; Storage of slightly transformed input of 'pat-events' 
;;; prepared for single voice processes 'voice-output'


(defclass voice-output-input-data ()
  ((option-key-vec :accessor option-key-vec
                   :initform (copy-seq *pe-vo-option-key-vec*)
                   :initarg :option-key-vec :initarg option-key-vec)
   (option-val-vec :accessor option-val-vec
                   :initform nil
                   :initarg :option-val-vec :initarg option-val-vec)
   (multiple-option?-vec :accessor multiple-option?-vec
                         :initform (make-array *vo-option-num* :initial-element nil)
                         :initarg :multiple-option?-vec :initarg multiple-option?-vec)
   (option-pat-type-vec :accessor option-pat-type-vec
                        :initform (make-array *vo-option-num* :initial-element nil)
                        :initarg :option-pat-type-vec :initarg option-pat-type-vec)
   (current-value-function-vec :accessor current-value-function-vec
                               :initform (make-array *vo-option-num* :initial-element nil)
                               :initarg :current-value-function-vec 
                               :initarg current-value-function-vec)
   (input-order->vo-key-pos-list :accessor input-order->vo-key-pos-list
                                 :initform nil
                                 :initarg :input-order->vo-key-pos-list
                                 :initarg input-order->vo-key-pos-list)
   ; list of positions of input-ordered options in option-key-vec, 
   ; may contain nils if input option to pat-events is not given to voice-output
   (option-num :initform *vo-option-num*
               :initarg :option-num :initarg option-num)
   (density :initform nil
            :initarg :vo-density :initarg vo-density)))



(defun vo-option-pat-type-ref (vo-input-data i j)
 (with-slots (multiple-option?-vec option-pat-type-vec) vo-input-data
  (if (aref multiple-option?-vec i)
      (aref (aref option-pat-type-vec i) j)
      (aref option-pat-type-vec i))))


(defun vo-option-val-ref (vo-input-data i j)
 (with-slots (multiple-option?-vec option-val-vec) vo-input-data
  (if (aref multiple-option?-vec i)
      (aref (aref option-val-vec i) j)
      (aref option-val-vec i))))


(defun vo-current-value-function-ref (current-value-function-vec i j)
  (if (arrayp (aref current-value-function-vec i))
      (aref (aref current-value-function-vec i) j)
      (aref current-value-function-vec i)))


; Reference functions 


(defun make-avoid-group-pat-ref-function-vec (pat density)
  (let* ((pat-name (object-name pat))
         (shadow-pat (new case 
                          :on pat-name
                          :by (t (new pval (pattern-last-value pat)))))
         groups)
    (loop with fns
          for i below density do
          (let ((j i))
            (push #'(lambda (x) (declare (ignore x))
                     (if (slot-value shadow-pat 'ref-pat-call)
                         (setf (slot-value shadow-pat 'ref-pat-call) nil
                               groups 
                               (coerce (make-voice-group-list 
                                        (next shadow-pat) density) 'array)))
                     (aref groups j))
                  fns))
          finally (return (coerce (reverse fns) 'array)))))


(defun make-pitch-scale-ref-function-vec (pitch-scale multiple-option? density)
  ; first call of reference function gives two values: pitch and predicate if new scale
  (loop with fns
        with scale
        for i below density do
        (setf scale
              (if multiple-option? 
                  (aref pitch-scale i)
                  pitch-scale))
        (if (not (pattern? scale))
            (let ((new-pitch-scale t))
                (push #'(lambda (x)
                          (values x (when new-pitch-scale
                                          (setf new-pitch-scale nil)
                                          t)))
                  fns))
            (let* ((pat-name (or (object-name scale)
                                 (error "pitch-scale-pattern must be named")))
                   (shadow-pat (new case 
                                    :on pat-name
                                    :by (t (new cycle of '(0))))))
              (push #'(lambda (x) 
                        (if (slot-value shadow-pat 'ref-pat-call)
                          (values (pattern-last-value x) (slot-value shadow-pat 'ref-pat-call))))
                    fns)))
        finally (return (coerce (reverse fns) 'array))))


(defun make-step-start-ref-function-vec (step-start multiple-option? pat-type-maybe-vec density)
  ; functions give four values: step-start, start status indicator (t, nil, eop or nad if just before)
  ; pattern type (nil, 0: event option control, 1: v-event option control)
  ; and the pattern itself if type 1
  (loop with fns
        for i below density 
        for start = (if multiple-option? 
                        (aref step-start i)
                        step-start)
        do
        (let ((pat-type (if (arrayp pat-type-maybe-vec)
                            (aref pat-type-maybe-vec i)
                            pat-type-maybe-vec)))
          (push (if (not (pattern? start))
                    #'(lambda (x) (values x t pat-type nil))
                    (cond ((= pat-type 0)
                           #'(lambda (x) (values (pattern-last-value x) 
                                                 (slot-value x 'last-state)
                                                 pat-type nil)))
                          ((= pat-type 1)
                           (let* ((pat-name (or (object-name start)
                                                (error "step-start-pattern must be named")))
                                  (shadow-pat (new case 
                                                   :on pat-name
                                                   :by (t (new cycle of '(0))))))
                             #'(lambda (x) (values (pattern-last-value x) 
                                                   (slot-value shadow-pat 'ref-pat-call) 
                                                   pat-type shadow-pat))))
                          (t (error "wrong pat-type"))))
                fns))
          finally (return (coerce (reverse fns) 'array))))


(defun set-current-value-function-vec (vo-input-data)    ; transforming vo-input-data
  (with-slots (option-key-vec option-val-vec option-num multiple-option?-vec 
               option-pat-type-vec current-value-function-vec density) vo-input-data
    (loop for i below option-num do  ; 
          (setf (aref current-value-function-vec i)
                (cond ((member (aref option-key-vec i) 
                               '(:avoid-octaves-group :avoid-primes-group))
                       (if (pattern? (aref option-val-vec i))
                           (make-avoid-group-pat-ref-function-vec
                            (aref option-val-vec i) density)
                           #'identity))
                      ((eql (aref option-key-vec i) :pitch-scale)
                       (make-pitch-scale-ref-function-vec  
                        (aref option-val-vec i) (aref multiple-option?-vec i) density))
                       ((eql (aref option-key-vec i) :step-start)
                       (make-step-start-ref-function-vec  
                        (aref option-val-vec i) (aref multiple-option?-vec i) 
                        (aref option-pat-type-vec i) density))
                       (t (map-anyway (if (or (not (aref multiple-option?-vec i))
                                              (every #'numberp (aref option-pat-type-vec i))
                                              (every #'null (aref option-pat-type-vec i)))
                                          (vo-option-pat-type-ref vo-input-data i 0)
                                          (aref option-pat-type-vec i))
                                      #'(lambda (x &optional j) (declare (ignore j))
                                         (if (null x) 
                                             #'identity 
                                             (cond ((member (aref option-key-vec i) 
                                                            '(:octave-step-horizon :pitch-rep-horizon))
                                                    #'buffer-pat-ref)
                                                   ((eql (aref option-key-vec i) :step-start)
                                                    #'identity)
                                                   (t #'pattern-last-value)))))))))
  current-value-function-vec))


; Making input data object for voice-output


(defun make-vo-input-data (pe-options pe-args input-density)
  (let ((vo-input-data (make-instance 'voice-output-input-data)) one-group?)
    (with-slots (option-key-vec option-val-vec option-num density input-order->vo-key-pos-list
                multiple-option?-vec option-pat-type-vec current-value-function-vec) vo-input-data
      (setf density input-density
            option-val-vec 
            (map 'array #'(lambda (x) (if (eql x :output-type)
                                          :midi
                                          (slot-value pe-options (symbol-of-key x)))) 
                 option-key-vec)
            input-order->vo-key-pos-list (loop for x on pe-args by #'cddr 
                                              collect (position (car x) option-key-vec)))
      (loop for i below option-num do
            (when (member (aref option-key-vec i) '(:no-8 :no-1) 
                          :test #'symbol-name-eql?)
                  (setf one-group? t
                        (aref option-val-vec i) ; special case grouping 
                        (cond ((one-group-of-length? (aref option-val-vec i) density)
                               (car (aref option-val-vec i)))
                              ((and (aref option-val-vec i)  
                                    (listp (aref option-val-vec i))
                                    (every #'listp (aref option-val-vec i)))
                               (setf one-group? nil)
                               (make-voice-group-list (aref option-val-vec i) density))
                              (t (aref option-val-vec i)))
                        (aref option-val-vec i)
                        (if (and one-group?  ; indicating no multiple option under further processing
                                 (not (null (aref option-val-vec i)))
                                 (not (symbolp (aref option-val-vec i))))
                            (coerce (aref option-val-vec i) 'array)
                            (aref option-val-vec i))))
            (cond ((null (aref option-val-vec i)))
                  ((listp (aref option-val-vec i))
                   (setf (aref multiple-option?-vec i) t
                         (aref option-pat-type-vec i)
                         (make-array density :initial-element nil))
                   (loop for j from 0
                         for item in (aref option-val-vec i) do
                         (cond ((pattern? item)
                                (setf (aref (aref option-pat-type-vec i) j) 0))
                               ((and (symbolp item)
                                     (not (member item '(t nil :midi))))
                                (setf (elt (aref option-val-vec i) j)
                                      (symbol-pat-reference item (slot-value pe-options 'v-data-pats) t)
                                      (aref (aref option-pat-type-vec i) j) 
                                      1))
                               (t nil)))
                   (setf (aref option-val-vec i) 
                         (coerce (aref option-val-vec i) 'array)))
                  (t (cond ((pattern? (aref option-val-vec i))
                            (setf (aref option-pat-type-vec i) 0))
                           ((and (symbolp (aref option-val-vec i))
                                 (not (member (aref option-val-vec i) '(t nil :midi))))
                            (setf (aref option-val-vec i)
                                  (symbol-pat-reference (aref option-val-vec i) 
                                                        (slot-value pe-options 'v-data-pats) t)
                                  (aref option-pat-type-vec i) 1))
                           (t nil))))
            (if (member (aref option-key-vec i) '(:no-reps :no-8-steps))
                (setf (aref option-val-vec i)
                      (map-anyway (aref option-val-vec i)
                                  #'(lambda (x &optional j) (declare (ignore j)) 
                                     (if (pattern? x) x (buffer-horizon x))))))
            (when one-group?   ; transforming back
                  (if (arrayp (aref option-val-vec i))
                      (setf (aref option-val-vec i) (coerce (aref option-val-vec i) 'list)))
                  (setf one-group? nil)))
      (repl-seq-items option-key-vec 
                      '(:no-8 :avoid-octaves-group :no-1 :avoid-primes-group :no-reps :pitch-rep-horizon 
                        :no-8-steps :octave-step-horizon))
      (repl-seq-items option-val-vec '(midi :midi) #'symbol-name-eql?)
      (set-current-value-function-vec vo-input-data))
    vo-input-data))
    
  

